Library Shredder;

Uses
  windows,
  bangs in 'bangs.pas',
  types in 'types.pas',
  api in 'api.pas';

function GetLitestepWnd:HWND; cdecl; external lsapi;

Function Callback_WndProc(Wnd, Msg: Integer; wParam, lParam: Longint): Longint; stdcall;
Var
  Buffer: PChar;

Begin
  Callback_WndProc := 0;
  Case Msg Of
     WM_TIMER:
       begin
         CheckRecycler;
       end;
     LM_GETREVID:  // Get our revision for '!About detailed'
       begin
         Buffer := PChar(lParam);
         if (wParam=0) then
           StrCopy(Buffer,PChar('Shredder.dll: '+revision))
         else if (wParam=1) then
           StrCopy(Buffer,revId)
         else
           StrCopy(Buffer,'');
         Callback_WndProc:=StrLen(Buffer);
      end;
     Else
       Callback_WndProc := DefWindowProc(Wnd,msg,wParam,lParam);
  End;
End;

Procedure CreateCallBackWnd;
Var
  Msgs:array [0..1] of longint;
  wc: Twndclass;
Begin
  If NOT GetClassInfo(Inst,'CommandClass',wc) then
  Begin
    FillChar(wc,sizeof(wc), #0);
    wc.lpfnWndProc := @Callback_WndProc;
    wc.lpszClassName := 'RCallBackClass';
    wc.hInstance := Inst;
    RegisterClassA(wc);
  End;
  CallBackWnd := CreateWindowExA(
      WS_EX_TOOLWINDOW,'RCallBackClass','',WS_POPUP,
      0,0,0,0,0,0,Inst,nil);

  if CallBackWnd=0 then
    Msgbox(0,'error creating window');

  Msgs[0] := LM_GETREVID;
  Msgs[1] := 0;
  SendMessage(GetLitestepWnd, LM_REGISTERMESSAGE, CallBackWnd, Integer(@Msgs));
End;

Procedure DestroyCallBackWnd;
Var
  Msgs:array [0..1] of longint;
  wc: Twndclass;
Begin
  Msgs[0] := LM_GETREVID;
  Msgs[1] := 0;
  SendMessage(GetLitestepWnd, LM_UNREGISTERMESSAGE, CallBackWnd, Integer(@Msgs));
  DestroyWindow(CallBackWnd);
  If GetClassInfo(Inst,'RCallBackClass',wc) then
    UnregisterClass('RCallBackClass',Inst);
End;

Function initModuleEx(ParentWnd:Integer;dllInst:Longint;szPath:PCHAR):longint; cdecl;
Var
  Buffer: PChar;
  SHQueryRBInfo: TSHQueryRBInfo;
begin
  Inst := dllInst;
  Startup := true;

  FullBang := StrAlloc(MAX_LINE_LENGTH);
  EmptyBang := StrAlloc(MAX_LINE_LENGTH);
  GetRCLine('ShredderFullBang',FullBang,MAX_LINE_LENGTH-1,'!none');
  GetRCLine('ShredderEmptyBang',EmptyBang,MAX_LINE_LENGTH-1,'!none');

  CreateCallBackWnd;

  Timer := SetTimer(CallBackWnd,42,2000,nil);
  RegisterBangs;
end;

Procedure quitModule(dllInst : Longint); cdecl;
begin
  UnRegisterBangs;
  KillTimer(CallBackWnd,42);
  StrDispose(FullBang);
  StrDispose(EmptyBang);
  DestroyCallBackWnd;
end;

Exports
  initModuleEx,
  quitModule;

end.