unit api;

interface
Uses
  types,
  Windows;

function StrAlloc(Size: Cardinal): PChar;
procedure StrDispose(Str: PChar);
function StrLen(tStr:PChar):integer;
function StrCopy(Dest, Source: PChar): PChar; assembler;
Procedure MsgBox(Flags: integer; Msg: String);

function SHEmptyRecycleBin(hWnd: HWND; pszRootPath: PChar; dwFlags: DWORD): HResult; stdcall;
function SHQueryRecycleBin(pszRootPath: PChar; var pSHQueryRBInfo: TSHQueryRBInfo): HResult; stdcall;

function GetDriveType(lpRootPathName: PChar): UINT; stdcall;
function GetLogicalDrives: DWORD; stdcall;
function GetLogicalDriveStrings(nBufferLength: DWORD; lpBuffer: PAnsiChar): DWORD; stdcall;

procedure CheckRecycler;

//LsApi Functions
function LCOpen(szPath: PChar): Integer; cdecl;
function LCReadNextConfig(F: integer; szPrefix,szBuffer : Pchar; dwLength: integer): Boolean; cdecl;
function GetRCInt(lpKeyName:PChar;nDefault:longint):longint; cdecl;
function GetRCLine(szKeyName: PChar; szBuffer: PChar;nBufLen: longint;szDefault: PChar):BOOL; cdecl;
function LCClose(F: integer): Boolean; cdecl;
function LSExecute(Owner: HWND;szCommand: AnsiString;nShowCmd: boolean):integer; cdecl;

implementation

Function Pot(b,e: integer):LongInt;
Begin
  If (e<=0) then
    Pot := 1
  Else
    Pot := b * Pot(b,e-1);
End;

Function Int2Str(Value: Integer): String;
Begin
  If (value<0) then
    Int2Str := '~'+Int2Str(Value*(-1))
  else
    If not((Value DIV 10) = 0) then
      result := Int2Str(Value DIV 10) + Chr(48 + (Value MOD 10))
    else
      result := Chr(48 + (Value Mod 10));
end;

function StrAlloc(Size: Cardinal): PChar;
begin
  Inc(Size, SizeOf(Cardinal));
  GetMem(Result, Size);
  Cardinal(Pointer(Result)^) := Size;
  Inc(Result, SizeOf(Cardinal));
end;

procedure StrDispose(Str: PChar);
begin
  if Str <> nil then
  begin
    Dec(Str, SizeOf(Cardinal));
    FreeMem(Str, Cardinal(Pointer(Str)^));
  end;
end;

function StrLen(tStr:PChar):integer;  // assembler version
asm
      MOV     EDX,7
      ADD     EDX,EAX                   { pointer+7 used in the end }
      PUSH    EBX                       { is necessary; even in your version}
      MOV     EBX,[EAX]                 { read first 4 bytes}
      ADD     EAX,4                     { increment pointer}
@L1:  LEA     ECX,[EBX-$01010101]       { subtract 1 from each byte}
      XOR     EBX,-1                    { invert all bytes}
      AND     ECX,EBX                   { and these two}
      MOV     EBX,[EAX]                 { read next 4 bytes}
      ADD     EAX,4                     { increment pointer}
      AND     ECX,80808080H             { test all sign bits}
      JZ      @L1                       { no zero bytes, continue loop}
      TEST    ECX,00008080H             { test first two bytes}
      JNZ     @L2                       { *was JNZ SHORT @L2*}
      SHR     ECX,16                    { not in the first 2 bytes}
      ADD     EAX,2
@L2:  SHL     CL,1                      { use carry flag to avoid a branch}
      POP     EBX                       { Likewise; see above}
      SBB     EAX,EDX                   { compute length}
end;

function StrCopy(Dest, Source: PChar): PChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        MOV     ESI,EAX
        MOV     EDI,EDX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     ECX
        MOV     EDI,ESI
        MOV     ESI,EDX
        MOV     EDX,ECX
        MOV     EAX,EDI
        SHR     ECX,2
        REP     MOVSD
        MOV     ECX,EDX
        AND     ECX,3
        REP     MOVSB
        POP     ESI
        POP     EDI
end;

Procedure MsgBox(Flags: integer; Msg: String);
begin
  MessageBoxEx(0,PChar(Msg),'Error',Flags,0);
end;

Procedure DetectHarddrives;
var
  drivemask,i: integer;
begin
  DriveTable.Drives := '';
  DriveTable.NumberOfDrives := 0;
  drivemask := GetLogicalDrives;
  for i:= 2 to 26 do
   If (drivemask AND Pot(2,i) = Pot(2,i)) then
    If GetDriveType(PChar(chr(65+i)+':\'))=DRIVE_FIXED then
     begin
       DriveTable.Drives := DriveTable.Drives+chr(65+i);
       Inc(DriveTable.NumberOfDrives);
     end;
end;

function EnumRecyclers: integer;
var
  SHQueryRBInfo: TSHQueryRBInfo;
  i,c: integer;
begin
  c := 0;
  SHQueryRBInfo.cbSize := sizeof(TSHQueryRBInfo);
  for i:= 1 to DriveTable.NumberOfDrives do
   begin
     SHQueryRecycleBin(PChar(DriveTable.Drives[i]+':\'), SHQueryRBInfo);
     Inc(c,SHQueryRBInfo.i64NumItems[0]);
   end;
  EnumRecyclers := c;
end;

procedure CheckRecycler;
var
  count: integer;
begin
  count := EnumRecyclers;

  If Startup then
   begin
     If (count > 0) Then
      begin
        isFull := true;
        LSExecute(0, PChar(FullBang), true);
      end else begin
        isFull := false;
        LSExecute(0, PChar(EmptyBang), true);
      end;
       Startup := false;
      end else
     If (NOT isFull)AND(count > 0) then
      begin
        isFull := true;
        LSExecute(0, PChar(FullBang), true);
      end else If isFull AND(count = 0) then
       begin
         isFull := false;
         LSExecute(0, PChar(EmptyBang), true);
       end;
end;

function SHEmptyRecycleBin; external shell32 name 'SHEmptyRecycleBinA';
function SHQueryRecycleBin; external shell32 name 'SHQueryRecycleBinA';

function GetDriveType; external kernel32 name 'GetDriveTypeA';
function GetLogicalDrives; external kernel32 name 'GetLogicalDrives';
function GetLogicalDriveStrings; external kernel32 name 'GetLogicalDriveStringsA';

//LsApi Functions
function LCOpen; external lsapi;
function LCReadNextConfig; external lsapi;
function GetRCInt; external lsapi;
function GetRCLine; external lsapi;
function LCClose; external lsapi;
function LSExecute; external lsapi;

begin
  DetectHarddrives;
end.
